VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmCrop 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Crop Image"
   ClientHeight    =   10680
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   13560
   Icon            =   "frmCrop.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   10680
   ScaleWidth      =   13560
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame Frame2 
      Caption         =   "JPEG Size Multiplier"
      Height          =   2295
      Left            =   10680
      TabIndex        =   7
      Top             =   5280
      Width           =   2775
      Begin VB.ListBox lstMultiplier 
         Height          =   1815
         Left            =   960
         TabIndex        =   8
         Top             =   360
         Width           =   735
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Crop Rectangle Color"
      Height          =   1215
      Left            =   10680
      TabIndex        =   4
      Top             =   7680
      Width           =   2775
      Begin VB.OptionButton optColor 
         Caption         =   "Black"
         Height          =   375
         Index           =   0
         Left            =   960
         TabIndex        =   6
         Top             =   240
         Value           =   -1  'True
         Width           =   735
      End
      Begin VB.OptionButton optColor 
         Caption         =   "White"
         Height          =   375
         Index           =   1
         Left            =   960
         TabIndex        =   5
         Top             =   720
         Width           =   735
      End
   End
   Begin VB.PictureBox picCrop 
      Appearance      =   0  'Flat
      ForeColor       =   &H80000008&
      Height          =   2775
      Left            =   10680
      ScaleHeight     =   2745
      ScaleWidth      =   2745
      TabIndex        =   3
      Top             =   2400
      Width           =   2775
   End
   Begin MSComDlg.CommonDialog dlgSaveAs 
      Left            =   11160
      Top             =   1080
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "&Return"
      Height          =   375
      Left            =   12240
      TabIndex        =   2
      Top             =   10180
      Width           =   1215
   End
   Begin VB.CommandButton cmdCreate 
      Caption         =   "&Create JPEG"
      Height          =   375
      Left            =   10680
      TabIndex        =   1
      Top             =   10180
      Width           =   1215
   End
   Begin VB.PictureBox picSource 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      Height          =   10455
      Left            =   120
      ScaleHeight     =   10395
      ScaleWidth      =   10395
      TabIndex        =   0
      Top             =   120
      Width           =   10455
      Begin VB.Shape shpCrop 
         Height          =   495
         Left            =   0
         Top             =   0
         Visible         =   0   'False
         Width           =   1215
      End
   End
End
Attribute VB_Name = "frmCrop"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'******* 01.30a Start *******
' Created form
'******* 01.30a End *********
Private mclsCrop As CCrop


Private Sub cmdCreate_Click()

    Const Cancel = 32755

    ' Crop the source picture
    mclsCrop.Crop picSource
    
    On Error Resume Next ' For cancel processing
    With dlgSaveAs
        .CancelError = True
        .DefaultExt = "jpg"
        .Filter = "JPEG Picture (*.jpg)|*.jpg"
    
        .Flags = cdlOFNOverwritePrompt _
                Or cdlOFNExtensionDifferent _
                Or cdlOFNPathMustExist _
                Or cdlOFNNoChangeDir
        .ShowSave
    End With
    
    If Err = Cancel Then
        Exit Sub
    End If
    On Error GoTo 0

    Dim lngIndex As Long
    For lngIndex = 0 To lstMultiplier.ListCount - 1
        If lstMultiplier.Selected(lngIndex) = True Then
            mclsCrop.CreateJPEG dlgSaveAs.Filename, _
                                CSng(lstMultiplier.List(lngIndex))
            Exit For
        End If
    Next
    
End Sub

Private Sub cmdExit_Click()

    Unload Me
    
End Sub


Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

    If KeyCode = vbKeyEscape Then
        Unload Me
    End If

End Sub

Private Sub Form_Load()

    Dim img As Picture
    '******* 01.40misc Start *******
'    Dim intTop As Integer
'    Dim intHeight As Integer
'    Dim intWidth As Integer
'    Dim intLeft As Integer
    '******* 01.40misc End *********

    Dim lngIndex As Long

    '******* 01.40misc Start *******
'    intTop = GetSetting(App.EXEName, "Options", "Crop Form Top", 0)
'    intHeight = GetSetting(App.EXEName, "Options", "Crop Form Height", 0)
'    intWidth = GetSetting(App.EXEName, "Options", "Crop Form Width", 0)
'    intLeft = GetSetting(App.EXEName, "Options", "Crop Form Left", 0)
'
'    If intHeight > 0 Then
'        Me.Move intLeft, intTop, intWidth, intHeight
'    Else
'        Me.Move (Screen.Width - Me.Width) / 2, (Screen.Height - Me.Height) / 2
'    End If
    '******* 01.40misc End *********
    
    Set mclsCrop = New CCrop
    mclsCrop.SLOP = 10
    
    ' This is a must or else the Freeimage cropping routines won't work
    picSource.ScaleMode = vbPixels
    
    picCrop.ScaleMode = vbPixels
    
    For lngIndex = 1 To 30
        lstMultiplier.AddItem Format$(lngIndex / 10, "0.0")
    Next
    ' Set the default at 1.0
    lstMultiplier.Selected(9) = True
    lstMultiplier.TopIndex = 9
    
    Set img = LoadPicture(mcolPictures(CStr(gintCurrentPic)).PicName)
    CenterPicture img, picSource
    frmDisplay.Hide
    
    If picCrop.Width <> picCrop.Height Then
        MsgBox "picCrop is not square and that will result in distorted preview images"
    End If
End Sub
Private Sub Form_Unload(Cancel As Integer)

    '******* 01.40misc Start *******
'    SaveSetting App.EXEName, "Options", "Crop Form Top", Me.Top
'    SaveSetting App.EXEName, "Options", "Crop Form Height", Me.Height
'    SaveSetting App.EXEName, "Options", "Crop Form Width", Me.Width
'    SaveSetting App.EXEName, "Options", "Crop Form Left", Me.Left
    '******* 01.40misc End *********

End Sub


Private Sub optColor_Click(Index As Integer)

    If optColor(0).Value = True Then
        shpCrop.BorderColor = vbBlack
    Else
        shpCrop.BorderColor = vbWhite
    End If

End Sub

Private Sub picSource_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    If mclsCrop.RectangleDrawn Then
        mclsCrop.Stretching = True
        mclsCrop.SaveMouse X, Y
    Else
        If optColor(0).Value = True Then
            shpCrop.BorderColor = vbBlack
        Else
            shpCrop.BorderColor = vbWhite
        End If
        mclsCrop.Start shpCrop, X, Y, picCrop
    End If

End Sub

Private Sub picSource_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

    If mclsCrop.Initialized Then
        If mclsCrop.RectangleDrawn Then
            If mclsCrop.Stretching Then
                mclsCrop.Stretch X, Y
                Set picCrop.Picture = Nothing
            Else
                mclsCrop.ShowGrabHandles X, Y
            End If
            mclsCrop.FillCropPic picSource, picCrop
        Else
            ' Draw the initial rectangle
            mclsCrop.DrawInitial X, Y
        End If
    End If

End Sub

Private Sub picSource_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

    If shpCrop.Visible Then
        mclsCrop.RectangleDrawn = True
    Else
        mclsCrop.RectangleDrawn = False
    End If
    mclsCrop.Stretching = False

End Sub
Private Sub CenterPicture(picJPG As StdPicture, PB As PictureBox)
'***************************************************************************
'Purpose:   Resize a picture to fit its target picturebox
'Inputs :   picJPG - the picture
'           PB - the target picturebox
'Outputs:   The resized picture
'***************************************************************************
    
    Dim sngWidth As Single
    Dim sngHeight As Single
    Dim sngNewWidth As Single
    Dim sngNewHeight As Single
    

    'Clear the Image  in the Picturebox
    PB.Cls
    
    'Get the size of the Image, but in the same Scale as the scale used by the PictureBox
    sngWidth = PB.ScaleX(picJPG.Width, vbHimetric, PB.ScaleMode)
    sngHeight = PB.ScaleY(picJPG.Height, vbHimetric, PB.ScaleMode)
         
    If sngWidth > PB.ScaleWidth Then
        ' Set the width to the width of the target picturebox
        sngNewWidth = PB.ScaleWidth
        ' Proportionally change the height
        sngHeight = sngHeight * (sngNewWidth / sngWidth)
    Else
        ' Set the height to the height of the target picturebox
        sngNewHeight = PB.ScaleHeight
        sngNewWidth = sngWidth
    End If
    
    If sngHeight > PB.ScaleHeight Then
        ' Set the height to the height of the target picturebox
        sngNewHeight = PB.ScaleHeight
        ' Proportionally change the width
        sngNewWidth = sngNewWidth * (sngNewHeight / sngHeight)
    Else
        sngNewHeight = sngHeight
    End If
    
    'Add resized and centered to Picturebox
'    PB.PaintPicture picJPG, (PB.ScaleWidth - sngNewWidth) / 2, _
'        (PB.ScaleHeight - sngNewHeight) / 2, _
'        sngNewWidth, sngNewHeight
    PB.PaintPicture picJPG, 0, _
        0, _
        sngNewWidth, sngNewHeight
        
End Sub




